unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, ComCtrls, StdCtrls, ExtCtrls, ScktComp, Machine, Programm;

type
  TForm1 = class(TForm)
    XPManifest: TXPManifest;
    StartupTimer: TTimer;
    GUIUpdateTimer: TTimer;
    CheckTimer: TTimer;
    MCUUpdateTimer: TTimer;
    MachineAnlaufTimer: TTimer;
    MachineLuefterNachlaufTimer: TTimer;
    ProgrammFertigAlarmTimer: TTimer;
    HeizenTimer: TTimer;
    FuellenTimer: TTimer;
    AusleerenTimer: TTimer;
    ReinigerTimer: TTimer;
    RegenerierenTimer: TTimer;
    WasserweicheTimer: TTimer;
    ProgrammTimer: TTimer;
    WWAutoTimer: TTimer;
    StatusBar: TStatusBar;
    StatusBox: TGroupBox;
    StatusBoxMachine: TGroupBox;
    Label3:  TLabel;
    LBL_Temp_Ist: TLabel;
    Text1:   TLabel;
    Text2:   TLabel;
    Text3:   TLabel;
    Text4:   TLabel;
    LBL_Temp_Soll: TLabel;
    LBL_Zulauf_Ist: TLabel;
    LBL_Zulauf_Soll: TLabel;
    Text5:   TLabel;
    Text6:   TLabel;
    LBL_Verbrauch: TLabel;
    LBL_Fuellstand: TLabel;
    Label11: TLabel;
    Text7:   TLabel;
    Text8:   TLabel;
    Label4:  TLabel;
    ProgressBarFuellstand: TProgressBar;
    ProgressBarTemperatur: TProgressBar;
    PNL_WWSyn: TPanel;
    PNL_WWOK: TPanel;
    PNL_WWOK_G: TPanel;
    PNL_WWUK: TPanel;
    StatusBoxSteuerung: TGroupBox;
    PNL_REL: TPanel;
    PNL_Umwaelzen: TPanel;
    PNL_Motoranlauf: TPanel;
    PNL_Heizung: TPanel;
    PNL_Zulauf: TPanel;
    PNL_Wasserweiche: TPanel;
    PNL_Reiniger: TPanel;
    PNL_Ablauf: TPanel;
    PNL_Luefter: TPanel;
    PNL_Regenerieren: TPanel;
    PNL_Alarm: TPanel;
    PNL_OK:  TPanel;
    GroupBox1: TGroupBox;
    PNL_HeizenLaeuft: TPanel;
    PNL_Korbwahl: TPanel;
    PNL_HeizenSolltErr: TPanel;
    PNL_ReinigerOffen: TPanel;
    MCUBox:  TGroupBox;
    Label5:  TLabel;
    Label6:  TLabel;
    Label7:  TLabel;
    Label8:  TLabel;
    LBL_Temp: TLabel;
    LBL_In:  TLabel;
    LBL_In_Sum: TLabel;
    LBL_WW_Zeit: TLabel;
    Label10: TLabel;
    PNL_MCU: TPanel;
    PNL_WWTaster: TPanel;
    ManControl: TGroupBox;
    Label1:  TLabel;
    Label2:  TLabel;
    Label13: TLabel;
    BTN_Man_HeizenBis: TButton;
    BTN_Man_HeizenStop: TButton;
    BTN_Man_FuellenBis: TButton;
    BTN_Man_Abpumpen: TButton;
    BTN_Man_Reiniger: TButton;
    Check_Umwaelzen: TCheckBox;
    Edit_HeizenSollwert: TEdit;
    BTN_Man_Regenerieren: TButton;
    BTN_Man_Korbwahl: TButton;
    BTN_Man2_Umwaelzen: TButton;
    Edit_FuellenSollwert: TEdit;
    BTN_Man2_Korbwahl: TButton;
    BTN_Man2_Reiniger: TButton;
    BTN_Man2_Regenerieren: TButton;
    BTN_Man2_Heizung: TButton;
    BTN_Man2_Zulauf: TButton;
    BTN_Man2_Ablauf: TButton;
    BTN_Man_Freigabe: TButton;
    EStopButton: TButton;
    ProgrammBox: TGroupBox;
    ProgrammText1: TLabel;
    ProgrammText2: TLabel;
    ProgrammText3: TLabel;
    Programm_Start: TButton;
    Programm_Stop: TButton;
    ProgrammInfo: TMemo;
    ProgrammProgressBar: TProgressBar;
    LogBox:  TGroupBox;
    Log:     TMemo;
    Tips:    TMemo;
    ResetButton: TButton;
    PNL_EN_IN: TPanel;
    Edit_Korb: TEdit;
    Timer1:  TTimer;
    Startab: TEdit;
    procedure WWAutoTimerTimer(Sender: TObject);
    procedure ProgrammTimerTimer(Sender: TObject);
    procedure BTN_Man_KorbwahlClick(Sender: TObject);
    procedure WasserweicheTimerTimer(Sender: TObject);
    procedure BTN_Man_HeizenBisClick(Sender: TObject);
    procedure BTN_Man_HeizenStopClick(Sender: TObject);
    procedure BTN_Man_FuellenBisClick(Sender: TObject);
    procedure BTN_Man_AbpumpenClick(Sender: TObject);
    procedure BTN_Man_RegenerierenClick(Sender: TObject);
    procedure BTN_Man_ReinigerClick(Sender: TObject);
    procedure AusleerenTimerTimer(Sender: TObject);
    procedure ReinigerTimerTimer(Sender: TObject);
    procedure RegenerierenTimerTimer(Sender: TObject);
    procedure FuellenTimerTimer(Sender: TObject);
    procedure HeizenTimerTimer(Sender: TObject);
    procedure ProgrammFertigAlarmTimerTimer(Sender: TObject);
    procedure MachineLuefterNachlaufTimerTimer(Sender: TObject);
    procedure MachineAnlaufTimerTimer(Sender: TObject);
    procedure BTN_Man2_AblaufClick(Sender: TObject);
    procedure BTN_Man2_ZulaufClick(Sender: TObject);
    procedure BTN_Man2_HeizungClick(Sender: TObject);
    procedure BTN_Man2_RegenerierenClick(Sender: TObject);
    procedure BTN_Man2_ReinigerClick(Sender: TObject);
    procedure BTN_Man2_KorbwahlClick(Sender: TObject);
    procedure BTN_Man2_UmwaelzenClick(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure Programm_StopClick(Sender: TObject);
    procedure Programm_StartClick(Sender: TObject);
    procedure EStopButtonClick(Sender: TObject);
    procedure BTN_Man_FreigabeClick(Sender: TObject);
    procedure MCUUpdateTimerTimer(Sender: TObject);
    procedure CheckTimerTimer(Sender: TObject);
    procedure GUIUpdateTimerTimer(Sender: TObject);
    procedure StartupTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure AddLogEntry(Entry: string);
    procedure AddTipEntry(Entry: string);
    procedure AddInfoEntry(Entry: string);
    procedure StatusMessage(Text: string);
    procedure MCUServerSocketWrite(Text: string);
    procedure RELServerSocketWrite(Text: string);
    procedure MCUServerSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure RELServerSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure Shutdown;
    procedure ProcessMCUCommand(Command: string);
    procedure ProcessRELCommand(Command: string);
    procedure GUIUpdate;
    procedure MCUUpdate;
    procedure SetMCUUpdateInterval(Interval: integer);
    procedure ManControlFreigabe(Status: boolean);
    procedure ResetMachine(SkipAllOff: boolean = False;
      SkipManControlOff: boolean = False);
    procedure StartFertigAlarm;
    procedure StopFertigAlarm;
    procedure HeizenStart(Solltemperatur: real; UmwaelzenNachHeizen: boolean;
      PrgmSchritt: boolean = False);
    procedure HeizenStop;
    procedure Fuellen(Sollmenge: real; PrgmSchritt: boolean = False);
    procedure Ausleeren(CustomTime: integer = 0; PrgmSchritt: boolean = False);
    procedure ReinigerOeffnen(PrgmSchritt: boolean = False);
    procedure Regenerieren(PrgmSchritt: boolean = False);
    procedure Korbwahl(SollPosition: integer; PrgmSchritt: boolean = False);
    procedure AutoWWStart(Interval: integer);
    procedure AutoWWStop;
  private
    { Private declarations }
  public
    { Public declarations }
    MCUServerSocket: TServerSocket;
    RELServerSocket: TServerSocket;
    Machine:  TMachine;
    Programm: TProgramm;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  TestMode: boolean = True;

  MCUServerSocketPort: integer = 10020;
  RELServerSocketPort: integer = 10021;

  //Timer-Intervalle
  ShutdownTime: integer      = 1000;
  StartupInterval: integer   = 1000;
  GUIUpdateInterval: integer = 250;
  CheckInterval: integer     = 2000;
  MCUUpdateInterval: integer = 2000;
  ManControlUpdateInterval: integer = 500;
  HeizenUpdateInterval: integer = 250;
  FuellenUpdateInterval: integer = 125;

  //Maximalwerte
  MaxTemp: integer = 73;
  MinTemp: integer = 11;
  MaxFuellstand: integer = 7;
  MaxWasserweicheVersuche: integer = 120;

  //Programm-Fertig Alarm
  FertigAlarmBeepInterval: integer = 800;
  FertigAlarmPauseInterval: integer = 10000;
  FertigAlarmBeeps: integer   = 3;
  FertigAlarmRepeats: integer = 3;

  //Heizen-Histerese
  //Berechnung: Zeit in Sekunden*(1000/HeizenUpdateInterval)
  HeizenEinHisterese = 120;
  HeizenAusHisterese = 140;

  //minimale Anzahl Impule, die beim Fllen innerhalb eines Zeitrahmens
  //erkannt werden mssen
  FuellenMinTicks = 1;  //Anzahl
  FuellenMinTicksCounterSteps = 60; //Zeitrahmen in ms/FuellenUpdateInterval

  //Maschinen-Zeiten in ms
  ReinigerOeffnenDauer = 30000;
  RegenerierenDauer = 20000;
  AusleerenDauer = 20000;

  //Wasserweichen-Interval
  KorbwahlStepInterval_Default: integer = 300;
  KorbwahlPauseInterval_Default: integer = 600;
  KorbwahlSteps_Default: integer   = 1;
  KorbwahlRepeats_Default: integer = 1;

  //Wasserweichen-Zeiten
  WasserweicheStepInterval: integer = 350;
  WasserweicheStepDiff: integer = 0;
  WasserweichePauseInterval: integer = 600;
  WasserweicheOKTime: integer   = 690;
  WasserweicheOKGTime: integer  = 2810;
  WasserweicheUKTime: integer   = 1280;
  WasserweicheSyncTime: integer = 3650;
  WasserweicheTimeDiff: integer = 120;


var
  BootupFlag: integer;
  MCUOnline, RELOnline, MCUError, RELError, MCUChecked, RELChecked: boolean;
  MCUCheckStep, RELCheckStep: integer;
  MachineOK, InManControl, MachineReset: boolean;

  FertigAlarmBeepOn, FertigAlarmTimerInPauseMode: boolean;
  FertigAlarmBeepsCount, FertigAlarmPauseCount:   integer;

  HeizenEinHistereseCounter, HeizenAusHistereseCounter: integer;
  HeizenFertig, WeiterUmwaelzen: boolean;
  HeizenSolltemperatur: real;
  PrgmSchrittHeizen:    boolean;

  FuellenSollmenge:   real;
  FuellenMinTicksCounter, FuellenOldTick: integer;
  PrgmSchrittFuellen: boolean;

  ReinigerZugegeben: boolean;

  PrgmSchrittAusleeren, PrgmSchrittReiniger, PrgmSchrittRegenerieren: boolean;

  PrgmSchrittKorbwahl: boolean;

  WasserweicheMode, WasserweicheVersuche: integer;
  WasserweicheSollPosition: integer;
  WasserweichePosition:     integer;
  //1=Sync
  //2=OK
  //3=OKG
  //4=UK

  AutoWWPosition: integer;

type
  TSTringdynarray = array of string;

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Alarm'}

procedure TForm1.StartFertigAlarm;
begin
  FertigAlarmBeepsCount := 0;
  FertigAlarmPauseCount := 0;
  FertigAlarmBeepOn     := False;
  FertigAlarmTimerInPauseMode := False;
  ProgrammFertigAlarmTimer.Interval := FertigAlarmBeepInterval;
  ProgrammFertigAlarmTimer.Enabled := True;
end;

procedure TForm1.StopFertigAlarm;
begin
  ProgrammFertigAlarmTimer.Enabled := False;
  Machine.Machine_Alarm(False);
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'MCU-Update'}

procedure TForm1.MCUUpdate;
begin
  if MCUOnline then
  begin
    MCUServerSocketWrite('GET_TEMP');
    MCUServerSocketWrite('GET_IN');
    MCUServerSocketWrite('GET_IN_SUM');
    MCUServerSocketWrite('GET_WW_TIME');
    MCUServerSocketWrite('GET_WW_STATE');
  end;
end;

procedure TForm1.SetMCUUpdateInterval(Interval: integer);
begin
  if MCUOnline then
  begin
    MCUUpdateTimer.Interval := Interval;
  end;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Explode und Kommandoverarbeitung'}

function Explode(const Separator, S: string; Limit: integer = 0): TStringDynArray;
var
  SepLen: integer;
  F, P:   PChar;
  ALen, Index: integer;
begin
  SetLength(Result, 0);
  if (S = '') or (Limit < 0) then
    Exit;
  if Separator = '' then
  begin
    SetLength(Result, 1);
    Result[0] := S;
    Exit;
  end;
  SepLen := Length(Separator);
  ALen   := Limit;
  SetLength(Result, ALen);

  Index := 0;
  P     := PChar(S);
  while P^ <> #0 do
  begin
    F := P;
    P := AnsiStrPos(P, PChar(Separator));
    if (P = nil) or ((Limit > 0) and (Index = Limit - 1)) then
      P := StrEnd(F);
    if Index >= ALen then
    begin
      Inc(ALen, 5);
      SetLength(Result, ALen);
    end;
    SetString(Result[Index], F, P - F);
    Inc(Index);
    if P^ <> #0 then
      Inc(P, SepLen);
  end;
  if Index < ALen then
    SetLength(Result, Index);
end;

procedure TForm1.ProcessMCUCommand(Command: string);
var
  CommandParts: TSTringdynarray;
begin
  CommandParts := Explode(';', Command);

  if Length(CommandParts) > 1 then
    if CommandParts[1] = 'ERROR' then
    begin
      MCUOnline := False;
      MCUError  := True;
      AddTipEntry('MCU Fehler');
    end;

  if CommandParts[0] = 'WELCOME' then
  begin
    MCUError  := False;
    MCUOnline := False;
  end
  else
  if CommandParts[0] = 'READY' then
  begin
    MCUChecked   := True;
    MCUCheckStep := 0;
    MCUOnline    := True;
    MCUError     := False;
  end
  else
  if CommandParts[0] = 'ERROR' then
  begin
    MCUOnline := False;
    MCUError  := True;
    AddTipEntry('MCU Fehler');
  end
  else
  if CommandParts[0] = 'EXIT' then
  begin
    MCUOnline := False;
    MCUError  := False;
    AddTipEntry('MCU beendet');
  end
  else
  if CommandParts[0] = 'CHECK' then
  begin
    if CommandParts[1] = 'OK' then
    begin
      MCUChecked := True;
      MCUError   := False;
      MCUOnline  := True;
    end
    else
    if CommandParts[1] = 'ERROR' then
    begin
      MCUChecked := False;
      MCUError   := True;
      AddTipEntry('MCU Check-Fehler');
    end;
  end
  else
  if CommandParts[0] = 'GET_TEMP' then
  begin
    Machine.SetMCUTemp(StrToInt(string(CommandParts[1])));
  end
  else
  if CommandParts[0] = 'GET_IN' then
  begin
    Machine.SetMCUIn(StrToInt(string(CommandParts[1])));
  end
  else
  if CommandParts[0] = 'GET_WW_TIME' then
  begin
    Machine.SetMCUWWTime(StrToInt(string(CommandParts[1])));
  end
  else
  if CommandParts[0] = 'GET_WW_STATE' then
  begin
    Machine.SetMCUWWState(StrToInt(string(CommandParts[1])));
  end
  else
  if CommandParts[0] = 'GET_IN_SUM' then
  begin
    Machine.SetMCUInSum(StrToInt(string(CommandParts[1])));
  end;

end;

procedure TForm1.ProcessRELCommand(Command: string);
var
  CommandParts: TSTringdynarray;
begin
  CommandParts := Explode(';', Command);

  if Length(CommandParts) > 1 then
    if CommandParts[1] = 'ERROR' then
    begin
      RELOnline := False;
      RELError  := True;
      AddTipEntry('REL Fehler');
    end;

  if CommandParts[0] = 'WELCOME' then
  begin
    RELError  := False;
    RELOnline := False;
  end
  else
  if CommandParts[0] = 'READY' then
  begin
    RELChecked   := True;
    RELCheckStep := 0;
    RELOnline    := True;
    RELError     := False;
  end
  else
  if CommandParts[0] = 'ERROR' then
  begin
    RELOnline := False;
    RELError  := True;
    AddTipEntry('REL Fehler');
  end
  else
  if CommandParts[0] = 'EXIT' then
  begin
    RELOnline := False;
    RELError  := False;
    AddTipEntry('REL Beendet');
  end
  else
  if CommandParts[0] = 'CHECK' then
  begin
    if CommandParts[1] = 'OK' then
    begin
      RELChecked := True;
      RELError   := False;
      RELOnline  := True;
    end
    else
    if CommandParts[1] = 'ERROR' then
    begin
      RELChecked := False;
      RELError   := True;
      AddTipEntry('REL Check-Fehler');
    end;
  end;

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Logs und Statuszeile'}

procedure TForm1.AddLogEntry(Entry: string);
var
  Memo: TMemo;
begin
  Memo := Form1.Log;
  Memo.Lines.Add(Entry);
  Memo.Perform(EM_LineScroll, 0, Memo.Lines.Count - 1);
end;

procedure TForm1.AddTipEntry(Entry: string);
var
  Memo: TMemo;
begin
  Memo := Form1.Tips;
  Memo.Lines.Add(Entry);
  Memo.Perform(EM_LineScroll, 0, Memo.Lines.Count - 1);
end;

procedure TForm1.AddInfoEntry(Entry: string);
var
  Memo: TMemo;
begin
  Memo := Form1.ProgrammInfo;
  Memo.Lines.Add(Entry);
  Memo.Perform(EM_LineScroll, 0, Memo.Lines.Count - 1);
end;

procedure TForm1.StatusMessage(Text: string);
begin
  StatusBar.Panels.Items[0].Text := Text;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Socket'}

procedure TForm1.MCUServerSocketWrite(Text: string);
var
  I: integer;
begin
  for I := 0 to MCUServerSocket.Socket.ActiveConnections - 1 do
    MCUServerSocket.Socket.Connections[I].SendText(':' + Text + ';');
  AddLogEntry('MCU<-: ' + Text);
end;

procedure TForm1.RELServerSocketWrite(Text: string);
var
  I: integer;
begin
  for I := 0 to RELServerSocket.Socket.ActiveConnections - 1 do
    RELServerSocket.Socket.Connections[I].SendText(':' + Text + ';');
  AddLogEntry('REL<-: ' + Text);
end;

procedure TForm1.MCUServerSocketRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Command: string;
  I: integer;
  CommandList: TSTringdynarray;
begin

  Command := Socket.ReceiveText;

  CommandList := Explode(':', Command);
  for I := 0 to length(CommandList) - 1 do
  begin
    Command := CommandList[I];
    if Command <> '' then
    begin
      ProcessMCUCommand(CommandList[I]);
      AddLogEntry('MCU->: ' + CommandList[I]);
    end;
  end;

end;

procedure TForm1.RELServerSocketRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Command: string;
  I: integer;
  CommandList: TSTringdynarray;
begin

  Command := Socket.ReceiveText;

  CommandList := Explode(':', Command);
  for I := 0 to length(CommandList) - 1 do
  begin
    Command := CommandList[I];
    if Command <> '' then
    begin
      ProcessRELCommand(CommandList[I]);
      AddLogEntry('REL->: ' + CommandList[I]);
    end;
  end;

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Reset'}

procedure TForm1.ResetMachine(SkipAllOff: boolean = False;
  SkipManControlOff: boolean = False);
begin
  ProgrammFertigAlarmTimer.Enabled := False;
  HeizenTimer.Enabled    := False;
  FuellenTimer.Enabled   := False;
  AusleerenTimer.Enabled := False;
  ReinigerTimer.Enabled  := False;
  RegenerierenTimer.Enabled := False;
  WasserweicheTimer.Enabled := False;

  if Programm.IsProgrammRunning then
    Programm.StopProgramm;
  if not SkipAllOff then
    Machine.Machine_AllOff;
  if not SkipManControlOff then
    ManControlFreigabe(False);
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'GUI-Buttons und ManControlFreigabe'}

procedure TForm1.ManControlFreigabe(Status: boolean);
begin

  if Status = False then
  begin
    BTN_Man_Freigabe.Caption := 'Freigabe';
    SetMCUUpdateInterval(MCUUpdateInterval);
    Machine.Disable_In;
  end
  else
  begin
    BTN_Man_Freigabe.Caption := 'Sperren';
    SetMCUUpdateInterval(ManControlUpdateInterval);
    Machine.Enable_In;
  end;

  BTN_Man_HeizenBis.Enabled := Status;
  BTN_Man_HeizenStop.Enabled := Status;
  BTN_Man_FuellenBis.Enabled := Status;
  BTN_Man_Abpumpen.Enabled := Status;
  BTN_Man_Reiniger.Enabled := Status;
  BTN_Man_Regenerieren.Enabled := Status;
  BTN_Man_Korbwahl.Enabled := Status;
  BTN_Man2_Umwaelzen.Enabled := Status;
  BTN_Man2_Korbwahl.Enabled := Status;
  BTN_Man2_Reiniger.Enabled := Status;
  BTN_Man2_Regenerieren.Enabled := Status;
  BTN_Man2_Heizung.Enabled := Status;
  BTN_Man2_Zulauf.Enabled := Status;
  BTN_Man2_Ablauf.Enabled := Status;

  Edit_HeizenSollwert.Enabled := Status;
  Edit_FuellenSollwert.Enabled := Status;
  Edit_Korb.Enabled := Status;
  Check_Umwaelzen.Enabled := Status;

  InManControl := Status;
end;

procedure TForm1.BTN_Man2_AblaufClick(Sender: TObject);
begin
  Machine.Machine_Abpumpen(not Machine.GetAbpumpenState);
end;

procedure TForm1.BTN_Man2_HeizungClick(Sender: TObject);
begin
  Machine.Machine_Heizen(not Machine.GetHeizenState);
end;

procedure TForm1.BTN_Man2_KorbwahlClick(Sender: TObject);
begin
  Machine.Machine_Korbwahl(not Machine.GetKorbwahlState);
end;

procedure TForm1.BTN_Man2_RegenerierenClick(Sender: TObject);
begin
  Machine.Machine_Regenerieren(not Machine.GetRegenerierenState);
end;

procedure TForm1.BTN_Man2_ReinigerClick(Sender: TObject);
begin
  Machine.Machine_Reiniger(not Machine.GetReinigerState);
end;

procedure TForm1.BTN_Man2_UmwaelzenClick(Sender: TObject);
begin
  Machine.Machine_Umwaelzen(not Machine.GetUmwaelzenState);
end;

procedure TForm1.BTN_Man2_ZulaufClick(Sender: TObject);
begin
  Machine.Machine_Zulauf(not Machine.GetZulaufState);
end;

procedure TForm1.BTN_Man_AbpumpenClick(Sender: TObject);
begin
  Ausleeren;
end;

procedure TForm1.BTN_Man_FreigabeClick(Sender: TObject);
begin
  if (MachineOK) and (Programm.IsProgrammRunning = False) then
  begin
    InManControl := not InManControl;
    ManControlFreigabe(InManControl);
    if InManControl = False then
      ResetMachine;
  end;
end;

procedure TForm1.BTN_Man_FuellenBisClick(Sender: TObject);
begin
  Fuellen(StrToFloat(Edit_FuellenSollwert.Text));
end;

procedure TForm1.BTN_Man_HeizenBisClick(Sender: TObject);
begin
  HeizenStart(StrToFloat(Edit_HeizenSollwert.Text), Check_Umwaelzen.Checked);
end;

procedure TForm1.BTN_Man_HeizenStopClick(Sender: TObject);
begin
  HeizenStop;
end;

procedure TForm1.BTN_Man_KorbwahlClick(Sender: TObject);
begin
  Korbwahl(StrToInt(Edit_Korb.Text));
end;

procedure TForm1.BTN_Man_RegenerierenClick(Sender: TObject);
begin
  Regenerieren;
end;

procedure TForm1.BTN_Man_ReinigerClick(Sender: TObject);
begin
  ReinigerOeffnen;
end;

procedure TForm1.EStopButtonClick(Sender: TObject);
begin
  ResetMachine;
end;

procedure TForm1.Programm_StartClick(Sender: TObject);
begin
  if Programm.IsProgrammRunning = False then
  begin
    ResetMachine;
    Programm.StartProgramm;
  end;
end;

procedure TForm1.Programm_StopClick(Sender: TObject);
begin
  Programm.StopProgramm;
end;

procedure TForm1.ResetButtonClick(Sender: TObject);
begin
  ResetMachine;
  MachineOk    := True;
  MachineReset := False;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'GUI Start/Ende, Shutdown'}

procedure TForm1.Shutdown;
begin
  AddLogEntry('Beende Programm');
  StatusMessage('Beende Programm');

  MCUServerSocketWrite('LOCK;0');
  RELServerSocketWrite('LOCK;0');

  MCUServerSocketWrite('EXIT');
  RELServerSocketWrite('EXIT');

  Sleep(ShutdownTime);

  MCUServerSocket.Close;
  RELServerSocket.Close;

  Halt;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Shutdown;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  AddLogEntry('Starte Server');
  StatusMessage('Starte...');

  MCUServerSocket      := TServerSocket.Create(Form1);
  MCUServerSocket.OnClientRead := MCUServerSocketRead;
  MCUServerSocket.Port := MCUServerSocketPort;
  MCUServerSocket.Open;

  RELServerSocket      := TServerSocket.Create(Form1);
  RELServerSocket.OnClientRead := RELServerSocketRead;
  RELServerSocket.Port := RELServerSocketPort;
  RELServerSocket.Open;

  AddLogEntry('Starte Clients');
  BootupFlag := 0;
  StartupTimer.Interval := StartupInterval;
  StartupTimer.Enabled := True;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'GUI-Update'}

function State2Color(State: boolean): TColor;
begin
  if State then
    State2Color := clLime
  else
    State2Color := clRed;
end;

procedure TForm1.GUIUpdate;
begin

  LBL_Temp_Ist.Caption   := Machine.GetGUITemp;
  LBL_Zulauf_Ist.Caption := Machine.GetGUIIn;
  LBL_Verbrauch.Caption  := Machine.GetGUIVerbrauch;
  LBL_Fuellstand.Caption := Machine.GetGUIFuellstand;

  ProgressBarFuellstand.Position := Round(Machine.GetFuellstand);
  ProgressBarTemperatur.Position := Round(Machine.GetTemp);

  PNL_MCU.Color := State2Color(MCUOnline);
  PNL_REL.Color := State2Color(RELOnline);
  PNL_OK.Color  := State2Color(MachineOK);

  PNL_Luefter.Color   := State2Color(Machine.GetKuehlungState);
  PNL_Alarm.Color     := State2Color(Machine.GetAlarmState);
  PNL_Umwaelzen.Color := State2Color(Machine.GetUmwaelzenState);
  PNL_Motoranlauf.Color := State2Color(Machine.GetAnlaufState);
  PNL_Wasserweiche.Color := State2Color(Machine.GetKorbwahlState);
  PNL_Reiniger.Color  := State2Color(Machine.GetReinigerState);
  PNL_Heizung.Color   := State2Color(Machine.GetHeizenState);
  PNL_Zulauf.Color    := State2Color(Machine.GetZulaufState);
  PNL_Ablauf.Color    := State2Color(Machine.GetAbpumpenState);
  PNL_Regenerieren.Color := State2Color(Machine.GetRegenerierenState);
  PNL_ReinigerOffen.Color := State2Color(ReinigerZugegeben);
  PNL_HeizenLaeuft.Color := State2Color(HeizenTimer.Enabled);
  PNL_HeizenSolltErr.Color := State2Color(HeizenFertig and HeizenTimer.Enabled);
  PNL_Korbwahl.Color  := State2Color(WasserweicheTimer.Enabled);

  LBL_Temp_Soll.Caption   := FloatToStrF(HeizenSolltemperatur, ffNumber, 15, 2) + ' C';
  LBL_Zulauf_Soll.Caption := FloatToStrF(FuellenSollmenge, ffNumber, 15, 2) + ' l';

  PNL_WWTaster.Color  := State2Color(Machine.GetWWState);
  PNL_EN_IN.Color     := State2Color(Machine.GetInEn);
  LBL_Temp.Caption    := IntToStr(Machine.GetMCUTemp);
  LBL_In.Caption      := IntToStr(Machine.GetMCUIn);
  LBL_In_Sum.Caption  := IntToStr(Machine.GetMCUInSum);
  LBL_WW_Zeit.Caption := IntToStr(Machine.GetWWTime);

  case WasserweichePosition of
    1:
    begin
      PNL_WWSyn.Color  := clLime;
      PNL_WWOK.Color   := clRed;
      PNL_WWOK_G.Color := clRed;
      PNL_WWUK.Color   := clRed;
    end;
    2:
    begin
      PNL_WWSyn.Color  := clRed;
      PNL_WWOK.Color   := clLime;
      PNL_WWOK_G.Color := clRed;
      PNL_WWUK.Color   := clRed;
    end;
    3:
    begin
      PNL_WWSyn.Color  := clRed;
      PNL_WWOK.Color   := clRed;
      PNL_WWOK_G.Color := clLime;
      PNL_WWUK.Color   := clRed;
    end;
    4:
    begin
      PNL_WWSyn.Color  := clRed;
      PNL_WWOK.Color   := clRed;
      PNL_WWOK_G.Color := clRed;
      PNL_WWUK.Color   := clLime;
    end;
  end;

  if MachineOK then
  begin
    Programm_Start.Enabled := not Programm.IsProgrammRunning;
    Programm_Stop.Enabled  := Programm.IsProgrammRunning;
  end
  else
  begin
    Programm_Start.Enabled := True;
    Programm_Stop.Enabled  := False;
  end;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Timer'}

procedure TForm1.StartupTimerTimer(Sender: TObject);
begin
  if BootupFlag = 0 then
  begin
    if TestMode then
    begin
      WinExec('MCU_TestClient.exe', SW_SHOWNORMAL);
      WinExec('Relaisboard_TestClient.exe', SW_SHOWNORMAL);
    end
    else
    begin
      WinExec('MCU_Client.exe', SW_SHOWNORMAL);
      WinExec('Relaisboard_Client.exe', SW_SHOWNORMAL);
    end;
    BootupFlag := 1;
  end
  else
  if BootupFlag = 1 then
  begin
    AddLogEntry('Clients gestartet');
    MCUServerSocketWrite('LOCK;1');
    RELServerSocketWrite('LOCK;1');
    BootupFlag := 2;
  end
  else
  if BootupFlag = 2 then
  begin
    StatusMessage('Initialisiere Programm');
    GUIUpdateTimer.Interval := GUIUpdateInterval;
    GUIUpdateTimer.Enabled  := True;
    SetMCUUpdateInterval(MCUUpdateInterval);
    MCUUpdateTimer.Enabled := True;
    ProgressBarFuellstand.Max := Round(MaxFuellstand);
    ProgressBarTemperatur.Max := Round(MaxTemp);
    ProgressBarTemperatur.Min := Round(MinTemp);
    BootupFlag := 3;
  end
  else
  begin
    StartupTimer.Enabled := False;
    MachineOK    := True;
    MachineReset := False;
    CheckTimer.Interval := CheckInterval;
    CheckTimer.Enabled := True;
    ResetButton.Enabled := True;
    EStopButton.Enabled := True;
    Programm_Start.Enabled := True;
    Programm_Stop.Enabled := True;
    BTN_Man_Freigabe.Enabled := True;
    Programm.InitProgramm;
    if MCUOnline then
      Machine.Disable_In;
    StatusMessage('Bereit');
  end;
end;

procedure TForm1.GUIUpdateTimerTimer(Sender: TObject);
begin
  GUIUpdate;
end;

procedure TForm1.HeizenTimerTimer(Sender: TObject);
begin

  if TestMode then
  begin

    HeizenFertig := True;
    HeizenSolltemperatur := Machine.GetTemp;
  end;

  if Machine.GetTemp >= MaxTemp then
  begin
    HeizenFertig := True;
    HeizenTimer.Enabled := False;
    MachineOK    := False;
    AddTipEntry('Maschine ber Maximaltemperatur ' + IntToStr(MaxTemp) + ' C');
  end
  else
  if Machine.GetTemp >= HeizenSolltemperatur then
  begin
    if HeizenFertig = False then
    begin
      HeizenAusHistereseCounter := HeizenAusHistereseCounter + 1;
      HeizenEinHistereseCounter := 0;
      if HeizenAusHistereseCounter >= HeizenAusHisterese then
      begin
        AddTipEntry('Solltemperatur ' + FloatToStr(HeizenSolltemperatur) +
          'C erreicht');
        HeizenFertig := True;
        Machine.Machine_Umwaelzen(WeiterUmwaelzen);
        Machine.Machine_Heizen(False);
        HeizenEinHistereseCounter := 0;
      end;
    end;
  end
  else
  begin
    if HeizenFertig = True then
    begin
      HeizenEinHistereseCounter := HeizenEinHistereseCounter + 1;
      HeizenAusHistereseCounter := 0;
      if HeizenEinHistereseCounter >= HeizenEinHisterese then
      begin
        AddTipEntry('Unter Solltemperatur');
        HeizenFertig := False;
        HeizenAusHistereseCounter := 0;
      end;
    end;
  end;




  if HeizenFertig = False then
  begin
    Machine.Machine_Umwaelzen(True);
    Machine.Machine_Heizen(True);
  end
  else
  begin
    if PrgmSchrittHeizen then
    begin
      ProgrammTimer.Enabled := True;
    end;
  end;

end;

procedure TForm1.WasserweicheTimerTimer(Sender: TObject);
var
  Zeit: integer;
begin

  //1=Sync
  //2=OK
  //3=OKG
  //4=UK

  if not TestMode then
  begin

    if WasserweicheMode = 0 then
    begin
      Machine.Machine_Korbwahl(True);
      WasserweicheTimer.Interval := WasserweicheStepInterval;
      WasserweicheMode := 1;
    end
    else if WasserweicheMode = 1 then
    begin
      Machine.Machine_Korbwahl(False);
      WasserweicheTimer.Interval := 200;
      WasserweicheMode := 2;
    end
    else if WasserweicheMode = 2 then
    begin
      if Machine.GetWWState = False then
      begin

        //WasserweicheTimer.Interval := 10;

        WasserweicheVersuche := WasserweicheVersuche + 1;

        if WasserweicheVersuche >= MaxWasserweicheVersuche then
        begin
          WasserweicheTimer.Enabled := False;
          Machine.Machine_Korbwahl(False);
          MachineOK := False;
          AddTipEntry('Wasserweiche reagiert nicht (max. Schaltversuche: ' +
            IntToStr(MaxWasserweicheVersuche) + ')');
        end
        else
        begin

          Zeit := Machine.GetWWTime - WasserweicheStepDiff;

          //if WasserweicheSollPosition = 2 then
          if (Zeit >= WasserweicheOKTime - WasserweicheTimeDiff) and
            (Zeit <= WasserweicheOKTime + WasserweicheTimeDiff) then
          begin
            WasserweichePosition := 2;
          end;

          //if WasserweicheSollPosition = 3 then
          if (Zeit >= WasserweicheOKGTime - WasserweicheTimeDiff) and
            (Zeit <= WasserweicheOKGTime + WasserweicheTimeDiff) then
          begin
            WasserweichePosition := 3;
          end;

          //if WasserweicheSollPosition = 4 then
          if (Zeit >= WasserweicheUKTime - WasserweicheTimeDiff) and
            (Zeit <= WasserweicheUKTime + WasserweicheTimeDiff) then
          begin
            WasserweichePosition := 4;
          end;

          //if WasserweicheSollPosition = 1 then
          if (Zeit >= WasserweicheSyncTime - WasserweicheTimeDiff) and
            (Zeit <= WasserweicheSyncTime + WasserweicheTimeDiff) then
          begin
            WasserweichePosition := 1;
          end;

          if WasserweichePosition = WasserweicheSollPosition then
          begin
            WasserweicheTimer.Enabled := False;
            Machine.Machine_Korbwahl(False);
            WasserweichePosition := WasserweicheSollPosition;

            if PrgmSchrittKorbwahl then
            begin
              ProgrammTimer.Enabled := True;
            end;

          end
          else
          begin
            WasserweicheMode := 3;
          end;

        end;
      end;
    end
    else if WasserweicheMode = 3 then
    begin
      WasserweicheTimer.Interval := WasserweichePauseInterval;
      WasserweicheMode := 0;
    end;

  end
  else
  begin
    WasserweichePosition      := WasserweicheSollPosition;
    WasserweicheTimer.Enabled := False;
    WasserweicheTimer.Enabled := False;
  end;

end;

procedure TForm1.WWAutoTimerTimer(Sender: TObject);
begin
  AutoWWPosition := AutoWWPosition + 1;
  if AutoWWPosition > 4 then
    AutoWWPosition := 2;
  Korbwahl(AutoWWPosition);
end;

procedure TForm1.CheckTimerTimer(Sender: TObject);
begin

  //if MCUOnline then
  if MCUCheckStep = 0 then
  begin
    MCUServerSocketWrite('CHECK');
    MCUChecked   := False;
    MCUCheckStep := 1;
  end
  else
  begin
    if MCUChecked <> True then
    begin
      //MCUOnline:=false;
      MCUError := True;
      AddTipEntry('MCU Antwort-Fehler/anderer Fehler');
    end;
    MCUCheckStep := 0;
  end;

  //if RELOnline then
  if RELCheckStep = 0 then
  begin
    RELServerSocketWrite('CHECK');
    RELChecked   := False;
    RELCheckStep := 1;
  end
  else
  begin
    if RELChecked <> True then
    begin
      //RELOnline:=false;
      RELError := True;
      AddTipEntry('REL Antwort-Fehler/anderer Fehler');
    end;
    RELCheckStep := 0;
  end;

  if (MCUOnline = False) or (RELOnline = False) or (MCUError = True) or
    (RELError = True) then
  begin
    MachineOK := False;
  end;

  if (MCUOnline = True) and (Machine.GetFuellstand >= MaxFuellstand) then
  begin
    AddTipEntry('Maschine luft ber...');
    MachineOK := False;
  end;

  if (MCUOnline = True) and (Machine.GetTemp >= MaxTemp) then
  begin
    MachineOK := False;
    AddTipEntry('Maschine ber Maximaltemperatur ' + IntToStr(MaxTemp) + ' C');
  end;

  if MachineOk = False then
  begin
    Sleep(500);

    if MachineReset then
      ResetMachine(True, True)
    else
      ResetMachine(False, True);

    MachineReset := True;
    ManControlFreigabe(True);
    StatusMessage('Fehler in der Steuerung! Bitte beheben und neu starten');
  end
  else
  begin
    StatusMessage('Bereit');
  end;

end;

procedure TForm1.MCUUpdateTimerTimer(Sender: TObject);
begin
  MCUUpdate;
end;

procedure TForm1.MachineAnlaufTimerTimer(Sender: TObject);
begin
  MachineAnlaufTimer.Enabled := False;
  Machine.Machine_Anlauf(False);
end;

procedure TForm1.MachineLuefterNachlaufTimerTimer(Sender: TObject);
begin
  if (Machine.GetAbpumpenState = False) and (Machine.GetReinigerState = False) and
    (Machine.GetHeizenState = False) then
    Machine.Machine_Kuehlung(False);
  MachineLuefterNachlaufTimer.Enabled := False;
end;

procedure TForm1.ProgrammFertigAlarmTimerTimer(Sender: TObject);
begin
  if FertigAlarmTimerInPauseMode then
  begin
    FertigAlarmTimerInPauseMode := False;
    FertigAlarmPauseCount := FertigAlarmPauseCount + 1;
    FertigAlarmBeepsCount := 0;
    ProgrammFertigAlarmTimer.Interval := FertigAlarmBeepInterval;
    FertigAlarmBeepOn     := False;
  end;

  if FertigAlarmTimerInPauseMode <> True then
  begin
    FertigAlarmBeepOn     := not FertigAlarmBeepOn;
    FertigAlarmBeepsCount := FertigAlarmBeepsCount + 1;
    Machine.Machine_Alarm(FertigAlarmBeepOn);

    if FertigAlarmBeepsCount = FertigAlarmBeeps * 2 then
    begin
      if FertigAlarmPauseCount = FertigAlarmRepeats - 1 then
      begin
        ProgrammFertigAlarmTimer.Enabled := False;
        Machine.Machine_Alarm(False);
      end
      else
      begin
        ProgrammFertigAlarmTimer.Interval := FertigAlarmPauseInterval;
        FertigAlarmTimerInPauseMode := True;
        Machine.Machine_Alarm(False);
      end;
    end;
  end;
end;

procedure TForm1.ProgrammTimerTimer(Sender: TObject);
begin
  ProgrammTimer.Enabled := False;
  Programm.NextStep;
end;

procedure TForm1.FuellenTimerTimer(Sender: TObject);
var
  BeendeFuellen: boolean;
begin
  BeendeFuellen := False;

  if TestMode then
    BeendeFuellen := True;

  if Machine.GetIn >= FuellenSollmenge then
  begin
    BeendeFuellen := True;
    AddTipEntry('Fuellmenge ' + FloatToStr(FuellenSollmenge) + 'l erreicht');
  end;
  if Machine.GetFuellstand >= MaxFuellstand then
  begin
    BeendeFuellen := True;
    AddTipEntry('Maximaler Fllstand von ' + FloatToStr(MaxFuellstand) + 'l erreicht');
    MachineOK := False;
  end;

  if not TestMode then
  begin

    FuellenMinTicksCounter := FuellenMinTicksCounter + 1;

    if FuellenMinTicksCounter >= FuellenMinTicksCounterSteps then
    begin
      FuellenMinTicksCounter := 0;
      if (Machine.GetMCUIn - FuellenOldTick) <= FuellenMinTicks then
      begin
        BeendeFuellen := True;
        AddTipEntry('Fllmenge in Zeitrahmen zu klein, Wasserhahn offen?');
        MachineOK := False;
      end;
      FuellenOldTick := Machine.GetMCUIn;
    end;
  end;

  if BeendeFuellen then
  begin
    Machine.Disable_In;
    Machine.Machine_Zulauf(False);
    FuellenTimer.Enabled := False;
    SetMCUUpdateInterval(MCUUpdateInterval);
    if PrgmSchrittFuellen then
    begin
      ProgrammTimer.Enabled := True;
    end;
  end
  else
  begin
    Machine.Machine_Zulauf(True);
  end;
end;

procedure TForm1.RegenerierenTimerTimer(Sender: TObject);
begin
  RegenerierenTimer.Enabled := False;
  Machine.Machine_Regenerieren(False);
  AddTipEntry('Regenerierung beendet');
  if PrgmSchrittRegenerieren then
  begin
    ProgrammTimer.Enabled := True;
  end;
end;

procedure TForm1.ReinigerTimerTimer(Sender: TObject);
begin
  ReinigerTimer.Enabled := False;
  Machine.Machine_Reiniger(False);
  AddTipEntry('Reinigerfach geffnet');
  ReinigerZugegeben := True;
  if PrgmSchrittReiniger then
  begin
    ProgrammTimer.Enabled := True;
  end;
end;

procedure TForm1.AusleerenTimerTimer(Sender: TObject);
begin
  Machine.Machine_Abpumpen(False);
  AusleerenTimer.Enabled := False;
  Machine.ResetFuellstand;
  AddTipEntry('Wasser abgepumpt');
  if PrgmSchrittAusleeren then
  begin
    ProgrammTimer.Enabled := True;
  end;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Heizen'}

procedure TForm1.HeizenStart(Solltemperatur: real; UmwaelzenNachHeizen: boolean;
  PrgmSchritt: boolean = False);
begin
  HeizenSolltemperatur := Solltemperatur;
  WeiterUmwaelzen      := UmwaelzenNachHeizen;
  PrgmSchrittHeizen    := PrgmSchritt;

  if Solltemperatur >= MaxTemp then
  begin
    MachineOK := False;
    AddTipEntry('Kann nicht ber maximale Maschinentemperatur heizen');
  end
  else
  begin
    if Machine.GetTemp >= HeizenSolltemperatur then
    begin
      HeizenFertig := True;
      HeizenEinHistereseCounter := HeizenEinHisterese;
      HeizenAusHistereseCounter := 0;
    end
    else
    begin
      HeizenFertig := False;
      HeizenEinHistereseCounter := 0;
      HeizenAusHistereseCounter := HeizenAusHisterese;
    end;

    SetMCUUpdateInterval(HeizenUpdateInterval);
    HeizenTimer.Interval := HeizenUpdateInterval;
    HeizenTimer.Enabled  := True;
    Machine.Machine_Umwaelzen(WeiterUmwaelzen);
  end;
end;

procedure TForm1.HeizenStop;
begin
  SetMCUUpdateInterval(MCUUpdateInterval);
  HeizenTimer.Enabled := False;
  HeizenFertig := True;
  Machine.Machine_Umwaelzen(WeiterUmwaelzen);
  Machine.Machine_Heizen(False);
  WeiterUmwaelzen := False;
  HeizenEinHistereseCounter := 0;
  HeizenAusHistereseCounter := 0;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Fllen'}

procedure TForm1.Fuellen(Sollmenge: real; PrgmSchritt: boolean = False);
begin

  FuellenSollmenge   := Sollmenge;
  PrgmSchrittFuellen := PrgmSchritt;
  FuellenMinTicksCounter := 0;
  FuellenOldTick     := 0;
  Machine.ResetIn;
  Sleep(250);
  SetMCUUpdateInterval(FuellenUpdateInterval);
  Sleep(500);
  Machine.Enable_In;
  FuellenTimer.Interval := FuellenUpdateInterval;
  FuellenTimer.Enabled  := True;

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Ausleeren'}

procedure TForm1.Ausleeren(CustomTime: integer = 0; PrgmSchritt: boolean = False);
begin
  PrgmSchrittAusleeren := PrgmSchritt;

  if CustomTime <> 0 then
    AusleerenTimer.Interval := CustomTime
  else
    AusleerenTimer.Interval := AusleerenDauer;

  AusleerenTimer.Enabled := True;
  Machine.Machine_Abpumpen(True);
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Reiniger, Regenerien'}

procedure TForm1.ReinigerOeffnen(PrgmSchritt: boolean = False);
begin
  PrgmSchrittReiniger    := PrgmSchritt;
  ReinigerTimer.Interval := ReinigerOeffnenDauer;
  ReinigerTimer.Enabled  := True;
  Machine.Machine_Reiniger(True);
  ReinigerZugegeben := False;
end;

procedure TForm1.Regenerieren(PrgmSchritt: boolean = False);
begin
  PrgmSchrittRegenerieren    := PrgmSchritt;
  RegenerierenTimer.Interval := RegenerierenDauer;
  RegenerierenTimer.Enabled  := True;
  Machine.Machine_Regenerieren(True);
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Korbwahl'}

 //1=Sync
 //2=OK
 //3=OKG
 //4=UK

procedure TForm1.Korbwahl(SollPosition: integer; PrgmSchritt: boolean = False);
begin

  if TestMode then
  begin
    WasserweichePosition := SollPosition;
  end;

  if WasserweichePosition <> SollPosition then
  begin
    PrgmSchrittKorbwahl := PrgmSchritt;

    Machine.Reset_WWTime;
    WasserweicheVersuche := 0;

    WasserweicheSollPosition := SollPosition;
    WasserweicheMode := 0;
    WasserweicheTimer.Enabled := True;
    WasserweicheTimer.Interval := 10;
  end
  else
  begin
    if PrgmSchritt then
      ProgrammTimer.Enabled := True;
    WasserweichePosition := SollPosition;
  end;
end;

procedure TForm1.AutoWWStart(Interval: integer);
begin
  AutoWWPosition      := WasserweichePosition;
  WWAutoTimer.Interval := Interval;
  WWAutoTimer.Enabled := True;
end;

procedure TForm1.AutoWWStop;
begin
  WWAutoTimer.Enabled := False;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

end.
