unit RS232_MCU;

interface

type
  TRS232_MCU = class
    procedure Connect;
    procedure Disconnect;
    function ReadADC: integer;
    function ReadCounter: integer;
    procedure ResetCounter;
    procedure EnableCounter;
    procedure DisableCounter;
    function ReadPortState: boolean;
    function Check: boolean;
    function ReadPortOnTime: integer;
    procedure ResetPortOnTime;
  end;

implementation

 //1=ADC lesen
 //2=Interrupt-Counter lesen
 //3=Interrupt-Counter reset
 //4=Interrupt-Counter starten
 //5=Interrupt-Counter sperren
 //6=Pin3-Status
 //7=Check
 //8=Pin3 Zeitmessung
 //9=Zeitmessung rcksetzen


{$REGION 'Initialisierung'}

procedure TRS232_MCU.Connect;
begin

end;

procedure TRS232_MCU.Disconnect;
begin

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'MCU-Funktionen'}

function TRS232_MCU.ReadADC: integer;
begin
  ReadADC := 561;
end;

function TRS232_MCU.ReadCounter: integer;
begin
  ReadCounter := 0;
end;

procedure TRS232_MCU.ResetCounter;
begin

end;

procedure TRS232_MCU.EnableCounter;
begin

end;

procedure TRS232_MCU.DisableCounter;
begin

end;

function TRS232_MCU.ReadPortState: boolean;
begin
  ReadPortState := False;
end; 

function TRS232_MCU.Check: boolean;

begin
  Check := True;
end;

function TRS232_MCU.ReadPortOnTime: integer;
begin
  ReadPortOnTime := 0;
end;

procedure TRS232_MCU.ResetPortOnTime;
begin

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

end.
